package contacter;

import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;

import com.google.gdata.data.DateTime;

public class LastProcess {
	private static final Logger log = Logger.getLogger(LastProcess.class.getName());
	private Query query;
	private String userIdFrom, userIdTo;
	private PersistenceManager pm;
	private LastProcessTable tableRecord;
	private Date lastProcessedDate;
	private int nbrItemsChangedInDestination;
	
	@SuppressWarnings("unchecked")
	public LastProcess(String userIdFrom, String userIdTo){
		
		this.userIdFrom = userIdFrom;
		this.userIdTo = userIdTo;
		
	    pm = PMF.get().getPersistenceManager();
	    
		query = pm.newQuery(LastProcessTable.class);
		query.setFilter("userIdFrom == userIdFromParam && userIdTo == userIdToParam");
		query.declareParameters("String userIdFromParam, String userIdToParam"); 
		 /*String query = "select from " + LastProcessTable.class.getName() + " where source == "
		 + "sourceParam && destination == destinationParam " +
		 "parameters String sourceParam, String destinationParam" ;*/
		 try{
			 List<LastProcessTable> lastProcessTable = (List<LastProcessTable>) query.execute(userIdFrom,userIdTo);
			 switch (lastProcessTable.size()){
				 case 0: lastProcessedDate = new Date(0);
					 	 tableRecord = new LastProcessTable(lastProcessedDate,userIdFrom,userIdTo,0);
						 pm.makePersistent(tableRecord);
						 //pm.close();
						 break;
				 case 1: tableRecord = lastProcessTable.get(0); 
				         lastProcessedDate = tableRecord.getlastProcessedDate();
				 		 break;
				 default:log.log(Level.SEVERE, "Error, more than 1 row found for " + userIdFrom + userIdTo + ". Using "
						 + lastProcessTable.get(0).getlastProcessedDate());
				 		 lastProcessedDate = tableRecord.getlastProcessedDate();
				 		 tableRecord = lastProcessTable.get(0);
						 break;
			 }
		 } finally{query.closeAll();}
	}

	public Date getLastProcessedDate(){
		return lastProcessedDate;
	}
	public void setLastProcessedDate(Date lastProcessedDate){
		this.lastProcessedDate = lastProcessedDate;
	}
	
	public int getNbrItemsChangedInDestination(){
		return nbrItemsChangedInDestination;
	}
	public void setNbrItemsChangedInDestination(int nbrItemsChangedInDestination){
		this.nbrItemsChangedInDestination = nbrItemsChangedInDestination;
	}
	
	public void commit(DateTime lastProcessedDate, int nbrItemsChangedInDestination){
		Date lastUpdateDate = new Date(lastProcessedDate.getValue());
		tableRecord.setLastProcessedDate(lastUpdateDate);
		tableRecord.setNbrItemsChangedInDestination(nbrItemsChangedInDestination);
		pm.makePersistent(tableRecord);
		pm.close();
	}
}
