package contacter;

import java.util.Date;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class LastProcessTable {
    @PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;
    
    @Persistent
    private Date lastProcessedDate;
    
    @Persistent
    private String userIdFrom;
    
    @Persistent
    private String userIdTo;
    
    @Persistent
    private int nbrItemsChangedInDestination;
    
    public LastProcessTable(Date lastProcessedDate, String userIdFrom, String userIdTo, 
    		int nbrItemsChangedInDestination) {
        this.lastProcessedDate = lastProcessedDate;
        this.userIdFrom = userIdFrom;
        this.userIdTo = userIdTo;
        this.nbrItemsChangedInDestination = nbrItemsChangedInDestination; 
    }
    public Key getKey(){
    	return key;
    }
    public Date getlastProcessedDate(){
    	return lastProcessedDate;
    }
    public String getUserIdFrom(){
    	return userIdFrom;
    }
    public String getUserIdTo(){
    	return userIdTo;
    }
    public int getNbrItemsChangedInDestination(){
    	return nbrItemsChangedInDestination;
    }
    
    public void setLastProcessedDate(Date lastProcessedDate){
    	this.lastProcessedDate = lastProcessedDate;
    }
    public void setUserIdFrom(String userIdFrom){
    	this.userIdFrom = userIdFrom;
    }
    public void setUserIdTo(String userIdTo){
    	this.userIdTo = userIdTo;
    }
    public void setNbrItemsChangedInDestination(int nbrItemsChangedInDestination){
    	this.nbrItemsChangedInDestination = nbrItemsChangedInDestination;	
    }
}
