package contacter;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import java.util.logging.Logger;

import javax.jdo.PersistenceManager;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class ListSyncTableServlet extends HttpServlet{
   private static Logger log = Logger.getLogger(ListSyncTableServlet.class.getName());
   
   public void doPost(HttpServletRequest req, HttpServletResponse resp)
   throws IOException { 
	 try{
	     UserService userService = UserServiceFactory.getUserService();
	     User user = userService.getCurrentUser(); 
	       
	     PersistenceManager pm = PMF.get().getPersistenceManager();
		 String query = "select from " + ContactLinksTable.class.getName();
		 List<ContactLinksTable> contactLinksTable = (List<ContactLinksTable>) pm.newQuery(query).execute();
		 if (contactLinksTable.isEmpty()) {
			 //log.info("No Contact Links.");
			 resp.sendRedirect("/welcome.jsp?message=No Contact Links.");
	     }  else{
	         PrintWriter out= resp.getWriter(); 
	         // Print the HTML header
	         out.println("<HTML><TITLE>");
	         out.println("Contacter - Back Up Sets</TITLE>");
	         out.println("<HEAD><link type='text/css' rel='stylesheet' href='/stylesheets/main.css' />");
	         out.println("</HEAD><BODY>");
	         out.println("<h4 align='right'> Bienvenue, " + user + 
	        		 " (<a href='<%= userService.createLogoutURL(request.getRequestURI()) %>'>sign out" +
	        				 "</a>)</h4>"); 
	         out.println("<h1 align='center' <img src='OrangeLogo.jpeg' align='center'>C-Sync.</h1>");
	    	 out.println("<table align='center' cellpadding='4' cellspacing='2' width='75%'>");
	    	 out.println("<tr><td bgcolor='#cccccc'>Contact Name</td>");
	    	 out.println("<td bgcolor='#cccccc'>Repositoryy</td>");
	    	 out.println("<td bgcolor='#cccccc'>ID on repository</td>");
	    	 out.println("<td bgcolor='#cccccc'>test3@gmail.com</td>");
	    	 out.println("<td bgcolor='#cccccc'>test4.sms@gmail.com</td>");
	    	 for (ContactLinksTable contactLinksRec : contactLinksTable) {
	        	 out.println("<tr>");
	        	 out.println("<td>" + contactLinksRec.getName()  + "</td>");
	        	 out.println("<td>" + contactLinksRec.getRepoName()  + "</td>");
	        	 out.println("<td>" + contactLinksRec.getIdOnRepo()  + "</td>");
	        	 out.println("<td>" + contactLinksRec.getTest3_gmail() + "</td>");
	        	 out.println("<td>" + contactLinksRec.getTest4_gmail() + "</td>");
	         }
	         out.println("</table></BODY></HTML>");
	         out.close();
	     }
		//resp.sendRedirect("/welcome.jsp");
	  }
	 catch (Exception e){
		   ErrorHandling.sendEMail(ErrorHandling.stackToString(e));
		   throw new RuntimeException(e); 
	 }
	}
}
